diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/ht/ht-frame-exchange-manager.cc ns-3.44/src/wifi/model/ht/ht-frame-exchange-manager.cc
--- ns-3.43/src/wifi/model/ht/ht-frame-exchange-manager.cc	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/ht/ht-frame-exchange-manager.cc	2025-03-09 16:55:49.791372500 -0700
@@ -1431,31 +1673,12 @@
                 // for this recipient
                 GetBaManager(tid)->AddToSendBarIfDataQueuedList(recipientMld, tid);
             }
-            resetCw = true;
         }
     }
     else
     {
         // we have to retransmit the data frames, if needed
-        GetWifiRemoteStationManager()
-            ->ReportAmpduTxStatus(recipient, 0, psdu->GetNMpdus(), 0, 0, txVector);
-        if (!GetWifiRemoteStationManager()->NeedRetransmission(*psdu->begin()))
-        {
-            NS_LOG_DEBUG("Missed Block Ack, do not retransmit the data frames");
-            GetWifiRemoteStationManager()->ReportFinalDataFailed(*psdu->begin());
-            for (const auto& mpdu : *PeekPointer(psdu))
-            {
-                NotifyPacketDiscarded(mpdu);
-                DequeueMpdu(mpdu);
-            }
-            resetCw = true;
-        }
-        else
-        {
-            NS_LOG_DEBUG("Missed Block Ack, retransmit data frames");
-            GetBaManager(tid)->NotifyMissedBlockAck(m_linkId, recipientMld, tid);
-            resetCw = false;
-        }
+        GetBaManager(tid)->NotifyMissedBlockAck(m_linkId, recipientMld, tid);
     }
 }
 
@@ -1463,9 +1686,10 @@
 HtFrameExchangeManager::SendBlockAck(const RecipientBlockAckAgreement& agreement,
                                      Time durationId,
                                      WifiTxVector& blockAckTxVector,
-                                     double rxSnr)
+                                     double rxSnr,
+                                     std::optional<Mac48Address> gcrGroupAddr)
 {
-    NS_LOG_FUNCTION(this << durationId << blockAckTxVector << rxSnr);
+    NS_LOG_FUNCTION(this << durationId << blockAckTxVector << rxSnr << gcrGroupAddr.has_value());
 
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_CTL_BACKRESP);
@@ -1481,8 +1705,12 @@
 
     CtrlBAckResponseHeader blockAck;
     blockAck.SetType(agreement.GetBlockAckType());
+    if (gcrGroupAddr.has_value())
+    {
+        blockAck.SetGcrGroupAddress(gcrGroupAddr.value());
+    }
     blockAck.SetTidInfo(agreement.GetTid());
-    agreement.FillBlockAckBitmap(&blockAck);
+    agreement.FillBlockAckBitmap(blockAck);
 
     Ptr<Packet> packet = Create<Packet>();
     packet->AddHeader(blockAck);
@@ -1495,7 +1723,7 @@
     // time, in microseconds between the end of the PPDU carrying the frame that
     // elicited the response and the end of the PPDU carrying the BlockAck frame.
     Time baDurationId = durationId - m_phy->GetSifs() -
-                        m_phy->CalculateTxDuration(psdu, blockAckTxVector, m_phy->GetPhyBand());
+                        WifiPhy::CalculateTxDuration(psdu, blockAckTxVector, m_phy->GetPhyBand());
     // The TXOP holder may exceed the TXOP limit in some situations (Sec. 10.22.2.8 of 802.11-2016)
     if (baDurationId.IsStrictlyNegative())
     {
@@ -1516,6 +1744,8 @@
                                     const WifiTxVector& txVector,
                                     bool inAmpdu)
 {
+    NS_LOG_FUNCTION(this << *mpdu << rxSignalInfo << txVector << inAmpdu);
+
     // The received MPDU is either broadcast or addressed to this station
     NS_ASSERT(mpdu->GetHeader().GetAddr1().IsGroup() || mpdu->GetHeader().GetAddr1() == m_self);
 
@@ -1543,15 +1773,14 @@
 
             m_txTimer.Cancel();
             m_channelAccessManager->NotifyCtsTimeoutResetNow();
-            Simulator::Schedule(m_phy->GetSifs(),
-                                &HtFrameExchangeManager::ProtectionCompleted,
-                                this);
+            ProtectionCompleted();
         }
         else if (hdr.IsBlockAck() && m_txTimer.IsRunning() &&
                  m_txTimer.GetReason() == WifiTxTimer::WAIT_BLOCK_ACK && hdr.GetAddr1() == m_self)
         {
             Mac48Address sender = hdr.GetAddr2();
             NS_LOG_DEBUG("Received BlockAck from=" << sender);
+            m_txTimer.GotResponseFrom(sender);
 
             SnrTag tag;
             mpdu->GetPacket()->PeekPacketTag(tag);
@@ -1560,17 +1789,44 @@
             CtrlBAckResponseHeader blockAck;
             mpdu->GetPacket()->PeekHeader(blockAck);
             uint8_t tid = blockAck.GetTidInfo();
-            std::pair<uint16_t, uint16_t> ret =
-                GetBaManager(tid)->NotifyGotBlockAck(m_linkId,
-                                                     blockAck,
-                                                     m_mac->GetMldAddress(sender).value_or(sender),
-                                                     {tid});
-            GetWifiRemoteStationManager()->ReportAmpduTxStatus(sender,
-                                                               ret.first,
-                                                               ret.second,
-                                                               rxSnr,
-                                                               tag.Get(),
-                                                               m_txParams.m_txVector);
+            if (blockAck.IsGcr())
+            {
+                const auto& gcrMembers = m_apMac->GetGcrManager()->GetMemberStasForGroupAddress(
+                    blockAck.GetGcrGroupAddress());
+                const auto ret = GetBaManager(tid)->NotifyGotGcrBlockAck(
+                    m_linkId,
+                    blockAck,
+                    m_mac->GetMldAddress(sender).value_or(sender),
+                    gcrMembers);
+
+                if (ret.has_value())
+                {
+                    for (const auto& sender : gcrMembers)
+                    {
+                        GetWifiRemoteStationManager()->ReportAmpduTxStatus(sender,
+                                                                           ret->first,
+                                                                           ret->second,
+                                                                           rxSnr,
+                                                                           tag.Get(),
+                                                                           m_txParams.m_txVector);
+                    }
+                }
+            }
+            else
+            {
+                const auto [nSuccessful, nFailed] = GetBaManager(tid)->NotifyGotBlockAck(
+                    m_linkId,
+                    blockAck,
+                    m_mac->GetMldAddress(sender).value_or(sender),
+                    {tid});
+
+                GetWifiRemoteStationManager()->ReportAmpduTxStatus(sender,
+                                                                   nSuccessful,
+                                                                   nFailed,
+                                                                   rxSnr,
+                                                                   tag.Get(),
+                                                                   m_txParams.m_txVector);
+            }
 
             // cancel the timer
             m_txTimer.Cancel();
@@ -1592,16 +1848,19 @@
             NS_ASSERT(hdr.GetAddr1() == m_self);
             NS_ABORT_MSG_IF(inAmpdu, "BlockAckReq in A-MPDU is not supported");
 
-            Mac48Address sender = hdr.GetAddr2();
+            auto sender = hdr.GetAddr2();
             NS_LOG_DEBUG("Received BlockAckReq from=" << sender);
 
             CtrlBAckRequestHeader blockAckReq;
             mpdu->GetPacket()->PeekHeader(blockAckReq);
             NS_ABORT_MSG_IF(blockAckReq.IsMultiTid(), "Multi-TID BlockAckReq not supported");
-            uint8_t tid = blockAckReq.GetTidInfo();
-
-            auto agreement = m_mac->GetBaAgreementEstablishedAsRecipient(sender, tid);
+            const auto tid = blockAckReq.GetTidInfo();
 
+            auto agreement = m_mac->GetBaAgreementEstablishedAsRecipient(
+                sender,
+                tid,
+                blockAckReq.IsGcr() ? std::optional{blockAckReq.GetGcrGroupAddress()}
+                                    : std::nullopt);
             if (!agreement)
             {
                 NS_LOG_DEBUG("There's not a valid agreement for this BlockAckReq");
@@ -1611,7 +1870,9 @@
             GetBaManager(tid)->NotifyGotBlockAckRequest(
                 m_mac->GetMldAddress(sender).value_or(sender),
                 tid,
-                blockAckReq.GetStartingSequence());
+                blockAckReq.GetStartingSequence(),
+                blockAckReq.IsGcr() ? std::optional{blockAckReq.GetGcrGroupAddress()}
+                                    : std::nullopt);
 
             NS_LOG_DEBUG("Schedule Block Ack");
             Simulator::Schedule(
@@ -1621,7 +1882,9 @@
                 *agreement,
                 hdr.GetDuration(),
                 GetWifiRemoteStationManager()->GetBlockAckTxVector(sender, txVector),
-                rxSnr);
+                rxSnr,
+                blockAckReq.IsGcr() ? std::optional{blockAckReq.GetGcrGroupAddress()}
+                                    : std::nullopt);
         }
         else
         {
@@ -1631,11 +1894,19 @@
         return;
     }
 
-    if (hdr.IsQosData() && hdr.HasData() && hdr.GetAddr1() == m_self)
-    {
-        uint8_t tid = hdr.GetQosTid();
-
-        if (m_mac->GetBaAgreementEstablishedAsRecipient(hdr.GetAddr2(), tid))
+    if (const auto isGroup = IsGroupcast(hdr.GetAddr1());
+        hdr.IsQosData() && hdr.HasData() &&
+        ((hdr.GetAddr1() == m_self) || (isGroup && (inAmpdu || !mpdu->GetHeader().IsQosNoAck()))))
+    {
+        const auto tid = hdr.GetQosTid();
+
+        auto agreement = m_mac->GetBaAgreementEstablishedAsRecipient(
+            hdr.GetAddr2(),
+            tid,
+            isGroup ? std::optional{hdr.IsQosAmsdu() ? mpdu->begin()->second.GetDestinationAddr()
+                                                     : hdr.GetAddr1()}
+                    : std::nullopt);
+        if (agreement)
         {
             // a Block Ack agreement has been established
             NS_LOG_DEBUG("Received from=" << hdr.GetAddr2() << " (" << *mpdu << ")");
@@ -1663,6 +1934,12 @@
         ReceiveMgtAction(mpdu, txVector);
     }
 
+    if (IsGroupcast(hdr.GetAddr1()) && hdr.IsQosData() && hdr.IsQosAmsdu() &&
+        !m_mac->GetRobustAVStreamingSupported())
+    {
+        return;
+    }
+
     QosFrameExchangeManager::ReceiveMpdu(mpdu, rxSignalInfo, txVector, inAmpdu);
 }
 
@@ -1735,7 +2012,9 @@
                 // agreement exists in BlockAckManager and we need to
                 // destroy it.
                 GetBaManager(delBaHdr.GetTid())
-                    ->DestroyRecipientAgreement(recipient, delBaHdr.GetTid());
+                    ->DestroyRecipientAgreement(recipient,
+                                                delBaHdr.GetTid(),
+                                                delBaHdr.GetGcrGroupAddress());
             }
             else
             {
@@ -1762,6 +2041,10 @@
                                         const WifiTxVector& txVector,
                                         const std::vector<bool>& perMpduStatus)
 {
+    NS_LOG_FUNCTION(
+        this << *psdu << rxSignalInfo << txVector << perMpduStatus.size()
+             << std::all_of(perMpduStatus.begin(), perMpduStatus.end(), [](bool v) { return v; }));
+
     std::set<uint8_t> tids = psdu->GetTids();
 
     // Multi-TID A-MPDUs are not supported yet
@@ -1785,9 +2068,77 @@
                 *agreement,
                 psdu->GetDuration(),
                 GetWifiRemoteStationManager()->GetBlockAckTxVector(psdu->GetAddr2(), txVector),
-                rxSignalInfo.snr);
+                rxSignalInfo.snr,
+                std::nullopt);
         }
+        else if (psdu->GetAddr1().IsGroup() && (ackPolicy == WifiMacHeader::NO_ACK))
+        {
+            // groupcast A-MPDU received
+            m_flushGroupcastMpdusEvent.Cancel();
+
+            /*
+             * There might be pending MPDUs from a previous groupcast transmission
+             * that have not been forwarded up yet (e.g. all transmission attempts
+             * of a given MPDU have failed). For groupcast transmissions using GCR-UR service,
+             * transmitter keeps advancing its window since there is no feedback from the
+             * recipients. In order to forward up previously received groupcast MPDUs and avoid
+             * following MPDUs not to be forwarded up, we flush the recipient window. The sequence
+             * number to use can easily be deduced since sequence number of groupcast MPDUs are
+             * consecutive.
+             */
+            const auto startSeq = psdu->GetHeader(0).GetSequenceNumber();
+            const auto groupAddress = psdu->GetHeader(0).IsQosAmsdu()
+                                          ? (*psdu->begin())->begin()->second.GetDestinationAddr()
+                                          : psdu->GetAddr1();
+            FlushGroupcastMpdus(groupAddress, psdu->GetAddr2(), tid, startSeq);
+
+            /*
+             * In case all MPDUs of all following transmissions are corrupted or
+             * if no following groupcast transmission happens, some groupcast MPDUs
+             * of the currently received A-MPDU would never be forwarded up. To prevent this,
+             * we schedule a flush of the recipient window once the MSDU lifetime limit elapsed.
+             */
+            const auto stopSeq = (startSeq + perMpduStatus.size()) % 4096;
+            const auto maxDelay = m_mac->GetQosTxop(tid)->GetWifiMacQueue()->GetMaxDelay();
+            m_flushGroupcastMpdusEvent =
+                Simulator::Schedule(maxDelay,
+                                    &HtFrameExchangeManager::FlushGroupcastMpdus,
+                                    this,
+                                    groupAddress,
+                                    psdu->GetAddr2(),
+                                    tid,
+                                    stopSeq);
+        }
+    }
+}
+
+void
+HtFrameExchangeManager::FlushGroupcastMpdus(const Mac48Address& groupAddress,
+                                            const Mac48Address& originator,
+                                            uint8_t tid,
+                                            uint16_t seq)
+{
+    NS_LOG_FUNCTION(this << groupAddress << originator << tid << seq);
+    // We can flush the recipient window by indicating the reception of an implicit GCR BAR
+    GetBaManager(tid)->NotifyGotBlockAckRequest(originator, tid, seq, groupAddress);
+}
+
+void
+HtFrameExchangeManager::NotifyLastGcrUrTx(Ptr<const WifiMpdu> mpdu)
+{
+    NS_LOG_FUNCTION(this << mpdu);
+    const auto tid = mpdu->GetHeader().GetQosTid();
+    const auto groupAddress = mpdu->GetHeader().GetAddr1();
+    if (!GetBaManager(tid)->IsGcrAgreementEstablished(
+            groupAddress,
+            tid,
+            m_apMac->GetGcrManager()->GetMemberStasForGroupAddress(groupAddress)))
+    {
+        return;
     }
+    GetBaManager(tid)->NotifyLastGcrUrTx(
+        mpdu,
+        m_apMac->GetGcrManager()->GetMemberStasForGroupAddress(groupAddress));
 }
 
 } // namespace ns3
